
//  Gestion de l'affichage de l'afficheur LCD par le 8255

#include <stdio.h>
#include <unistd.h>
#include <asm/io.h>
#include <math.h>
#include "lcd.h"

void envoi_LCD(int valeur1,int valeur2)
{
 usleep(20000);
 outb(valeur1+8,0x300);
 outb(valeur1+4+8,0x300);
 outb(valeur1+8,0x300);

 outb(valeur2+8,0x300);
 outb(valeur2+4+8,0x300);
 outb(valeur2+8,0x300);
}

void envoi_LCD_lent(int valeur1,int valeur2)
{
 usleep(1500);
 outb(valeur1+8,0x300);
 outb(valeur1+4+8,0x300);
 outb(valeur1+8,0x300);

 usleep(1500);
 outb(valeur2+8,0x300);
 outb(valeur2+4+8,0x300);
 outb(valeur2+8,0x300);
}

void affiche_caractere(char ascii)
{
       int v1=1,v2=1;

        // Affiche un caractere
        if (ascii&128)  v1=v1+128;  
        if (ascii&64)  v1=v1+64;   
        if (ascii&32)  v1=v1+32;   
        if (ascii&16)  v1=v1+16;   

        if (ascii&8)  v2=v2+128;  
        if (ascii&4)  v2=v2+64;   
        if (ascii&2)  v2=v2+32;   
        if (ascii&1)  v2=v2+16;   

        envoi_LCD(v1,v2); 

}

void efface_ecran()
{
        // Clear display
        envoi_LCD_lent(0,16);
}

void init8255()
{

        // port: 300 = A Afficheur LCD (sortie)
        //       301 = B IR (entree)  
        //       302 = C poid faible = entree (botte secrete)
        //       302 = C poid fort = sortie (Relais)
        //       303 = config
      
        int i;

        if( (ioperm (0x300,0x4/*taille max d'addressage*/,0x300))== 0)
                printf("Ioperm 8255 (LCD) Ok\n");


        i=inb(0x300);
        printf("valeur du port %d\n",i); 

        if (i&8) {   
          // deja initialise, on ne reinitialise pas.
          printf("LCD deja initialise\n");

        }
        else {

         printf("Initialisation du LCD\n");

         // Init du 8255
//         outb(0x8b,0x303); Ancienne valeur avant relais
         outb(0x83,0x303);
 
         // init de l'afficheur LCD
      
         // System set   first
         usleep(30000);
         outb(32+8,0x300);
         usleep(1);
         outb(32+4+8,0x300);
         usleep(1);
         outb(32+8,0x300);

         usleep(15000);

         // System set bis
         envoi_LCD_lent(32,128);

         usleep(15000);

         // Set ON/OFF
         envoi_LCD_lent(0,128+64+32);  //32 ?

         usleep(15000);
 
         // Entry mode set
         envoi_LCD_lent(0,64+32);

         usleep(15000);

         printf("Fin init LCD Ok\n");

        }
 
        efface_ecran();

}

void scrool_ecran()
{
 envoi_LCD(16,128);
}

void va_ecran(int pos)
{
 int v1=0;
 int v2=0;

 if (pos&1) v2=v2+16;
 if (pos&2) v2=v2+32;
 if (pos&4) v2=v2+64;
 if (pos&8) v2=v2+128;
 if (pos&16) v1=v1+16;
 if (pos&32) v1=v1+32;
 if (pos&64) v1=v1+64;
 if (pos&128) v1=v1+128;

 envoi_LCD(128+v1,v2);
}

void* lcd(void* rien)
{
 int i=0;
 char pos[17];
 char c=32;
 int etoile=0; // j'ai rajoute ca pour avoir une etoile qui cliniotte a la fin

 int cmp=0;

 init8255();

 efface_ecran(); // Deplace

 while(1)	//ou plutot while(ON) ou ON est une autre var globale
 {

  if (cmp++==10) 
  {
   cmp=0;
   efface_ecran(); // Efface tout
  }

 //  printf("Affichage LCD\n");

  if (etoile==0) // Je suis sur que tu pourra faire ca beaucoup mieux que moi :)
  {
   etoile=1;
   sprintf(pos,"%3.0f %3.0f %4.0f ***",x_robot,y_robot,180*angle_robot/M_PI);
  }
  else
  {
   etoile=0;
   sprintf(pos,"%3.0f %3.0f %4.0f",x_robot,y_robot,180*angle_robot/M_PI);
  }
 
  i=0;

  va_ecran(0);   // Il faudra mieux mettre ca a la place d'efface ecran
                 // pour eviter le clignottement
                 // Mais a ce moment la il fo bien afficher jusqua la fin
		 // de la ligne              
		 // et de plus fodrait rajouter un truc qui "clignotte"     

  while((msg[i]!='\0')&&(i<16)) affiche_caractere(msg[i++]);
  for(;i<16;i++) affiche_caractere(c);    

  va_ecran(64);
  i=0;
  while(pos[i]!='\0') affiche_caractere(pos[i++]);
  for(;i<16;i++) affiche_caractere(c);    
 }
}
